#!/usr/bin/python2.7

#############################################################################
# Copyright (C) Labomedia May 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franproplin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################

from twisted.internet import reactor
from txosc import async, dispatch, osc

from time import time, sleep

t_pulse = time()

class gameManagement(object):
    '''Create management Dictionnary with all datas from all players'''
    def __init__(self):
        # address:   message 7 values
        # ip, socket: master,number,score,batx,baty,ballx,bally
        self.manage = {}
        ##self.manage = {('10.0.0.5',78945):[0,8,0,5,8,5,1]}
        self.master = ()
        self.numbers = []
        self.ACTA = {}

    def insert_data_in_dict(self, message, address):
        mst, who = 0, 11
        # get master and number
        if self.manage:# no empty
            for key, value in self.manage.items():
                if value[0] == 1:
                    mst = 0
                if value[0] == 0:
                    mst = 1
        else: # manage empty
            mst = 1

        # get player number
        self.numbers = []
        if self.manage:# no empty
            for key, value in self.manage.items():
                self.numbers.append(value[1])
        self.numbers.sort()
        try:
            who = self.numbers[-1] + 1
        except:
            who = 1

        # Get master and number in dict
        if address in self.manage:
            master_number = [self.manage[address][0], self.manage[address][1]]
        else:
            master_number = [mst, who]
        data = master_number
        data.extend(message)

        # Fill the table
        self.manage[address] = data
        #print self.manage
        # add in dict to control web
        self.ACTA[address] = time()

    def delete_disconnected_player(self):
        print self.ACTA
        for addr, t in self.ACTA.items():
            if time() -t > 0.5:
                del self.manage[addr]
                del self.ACTA[addr]
                print "Deleted in ACTA, in manage, and I kill the player: ", addr
                print self.manage, self.ACTA

    def create_msg_for_all_players(self):
        self.msg = osc.Message("/for_all_players")
        for key, value in self.manage.items():
            self.msg.add(key[0])
            for item in value:
                self.msg.add(item)
        #print self.msg
        return self.msg

if __name__ == "__main__":
    # only to test
    # set instance of class
    game = gameManagement()

    test = [ [('10.0.0.9', 47582), [10, -9.4, 0.0, 0.0, 0.0]],
            [('10.0.0.9', 41258), [5, 5.4, 85, -1.3, 0.0]],
            [('10.0.0.111', 65874), [0, 7.4, 1.2, 5.2, -1.4]]  ]

    for t in test:
        game.insert_data_in_dict(t[1], t[0])
        game.create_msg_for_all_players()

    game.delete_disconnected_player()
