#!/usr/bin/python2.7

#############################################################################
# Copyright (C) Labomedia May 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franproplin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################

import sys
import threading
try:
    from twisted.internet import reactor
    from txosc import async, dispatch, osc
except:
    print "You must install python-txosc and maybe python-twisted"
from time import time, sleep
import managementDict

# set instance of class
game = managementDict.gameManagement()

# init
host_multicast = "224.0.0.11"
port_multicast = 18888
tinit = time()
t1 = time()
t2 = time()
##t3 = time()

global multicast_sender
global  multicast_reicever

def main():
    print "Game Server\n MultiPass For Freedom\n\n"
    print 'Press q + Enter to quit\n'

    # Set instance
    global multicast_sender
    global  multicast_reicever
    multicast_sender = UDPMulticastSender(port_multicast)
    multicast_reicever = UDPMulticastReceiver(port_multicast)

    thread1=threading.Thread(target=thread_keyboard)
    thread1.start()

    reactor.run()

def player_data_handler(message, address):
    '''
    This function is called every received message from every player.
    So all data are collected here.
    The frequency of this function is the frequency of blender * players number
    With 4 players: 60 * 4 = 240 Hz
    The frequency of dispatched messages must be 60 Hz because Blender
    received at 60 Hz at the best.
    '''
    # insert data
    # message.getValues() is a list with data
    global game
    global multicast_sender
    game.insert_data_in_dict(message.getValues(), address)

    # send at 60 Hz maxi
    global t1
    if time() - t1 > 0.015:
        t1 = time()
        msg_for_all_players = game.create_msg_for_all_players()
        multicast_sender.send_message(msg_for_all_players)
        global t2
        if time() - t2 > 1:
            t2 = time()
            if msg_for_all_players:
                #print msg_for_all_players
                game.delete_disconnected_player()

class UDPMulticastSender(object):
    def __init__(self, port, host=host_multicast):
        self.port = port
        self.host = host
        self.client = async.DatagramClientProtocol()
        self._client_port = reactor.listenUDP(0, self.client)
        print("Sending multicast on: %s : %s" % (self.host, self.port))

    def send_message(self, message):
        self.client.send(message, (self.host, self.port))

class UDPMulticastReceiver(object):
    def __init__(self, port):
        self.port = port
        self.receiver = dispatch.Receiver()
        self._server_port = reactor.listenMulticast(self.port,
            async.MulticastDatagramServerProtocol(self.receiver, host_multicast),
            listenMultiple=True)
        print("Listening multicast on: %s : %s" % (host_multicast, self.port))
        # handler for all usefull data from a player
        self.receiver.addCallback("/player_data", player_data_handler)

    def quit_handler(self, message, address):
        print("Quit : Got %s from %s" % (message, address))
        reactor.stop()
        print("Goodbye.")
        try:
            exit(0)
        except:
            pass

def thread_keyboard():
    q_quit = False
    while not q_quit:
        c = sys.stdin.read(1)
        if c == 'q':  # exit program
            print 'Exit thread keyboard'
            # Stop this loop
            q_quit = True
            global reactor
            reactor.stop()
            print "Server stop"
            sleep(1)
            print "Exit"
            sys.exit(2)

main()


